今天老师(orz sansirowaltz)让我们做了很久之前的一场Codeforces Round #257 (Div. 1),这里给出A~C的题解,对应DIV2的C~E。

A.Jzzhu and Chocolate
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Jzzhu has a big rectangular chocolate bar that consists of n × m unit squares. He wants to cut this bar exactly k times. Each cut must meet the following requirements:

  • each cut should be straight (horizontal or vertical);
  • each cut should go along edges of unit squares (it is prohibited to divide any unit chocolate square with cut);
  • each cut should go inside the whole chocolate bar, and all cuts must be distinct.

The picture below shows a possible way to cut a 5 × 6 chocolate for 5 times.

Imagine Jzzhu have made k cuts and the big chocolate is splitted into several pieces. Consider the smallest (by area) piece of the chocolate, Jzzhu wants this piece to be as large as possible. What is the maximum possible area of smallest piece he can get with exactly k cuts? The area of a chocolate piece is the number of unit squares in it.

Input

A single line contains three integers n, m, k (1 ≤ n, m ≤ 109; 1 ≤ k ≤ 2·109).

Output

Output a single integer representing the answer. If it is impossible to cut the big chocolate k times, print -1.

Examples
input
3 4 1
output
6
input
6 4 2
output
8
input
2 3 4
output
-1
Note

In the first sample, Jzzhu can cut the chocolate following the picture below:

In the second sample the optimal division looks like this:

In the third sample, it's impossible to cut a 2 × 3 chocolate 4 times.

这题是数学问题,感觉没什么好说的,就是注意long long和细节,很容易WA掉。

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
using namespace std; int k;
long long n,m;
long long ans; int main()
{
scanf("%I64d%I64d%d",&n,&m,&k);
if(n<k+1 && m<k+1)
{
if(n+m-2<k)
{
printf("%d\n",-1);
return 0;
}
printf("%I64d\n",max((n/(k-m+2)),m/(k-n+2)));
return 0;
}
if(n/(k+1)*m>m/(k+1)*n)
printf("%I64d\n",n/(k+1)*m);
else
printf("%I64d\n",m/(k+1)*n);
return 0;
}

  

B. Jzzhu and Cities
time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Jzzhu is the president of country A. There are n cities numbered from 1 to n in his country. City 1 is the capital of A. Also there are mroads connecting the cities. One can go from city ui to vi (and vise versa) using the i-th road, the length of this road is xi. Finally, there are k train routes in the country. One can use the i-th train route to go from capital of the country to city si (and vise versa), the length of this route is yi.

Jzzhu doesn't want to waste the money of the country, so he is going to close some of the train routes. Please tell Jzzhu the maximum number of the train routes which can be closed under the following condition: the length of the shortest path from every city to the capital mustn't change.

Input

The first line contains three integers n, m, k (2 ≤ n ≤ 105; 1 ≤ m ≤ 3·105; 1 ≤ k ≤ 105).

Each of the next m lines contains three integers ui, vi, xi (1 ≤ ui, vi ≤ nui ≠ vi; 1 ≤ xi ≤ 109).

Each of the next k lines contains two integers si and yi (2 ≤ si ≤ n; 1 ≤ yi ≤ 109).

It is guaranteed that there is at least one way from every city to the capital. Note, that there can be multiple roads between two cities. Also, there can be multiple routes going to the same city from the capital.

Output

Output a single integer representing the maximum number of the train routes which can be closed.

Examples
input
5 5 3
1 2 1
2 3 2
1 3 3
3 4 4
1 5 5
3 5
4 5
5 5
output
2
input
2 2 3
1 2 2
2 1 3
2 1
2 2
2 3
output
2

思路:跑一遍最短路spfa,然后记录经过的边(如果普通边和铁路在某种情况下一样优则选择普通边),若其中有铁路就保留,反之不在最短路径中的铁路删除,cout删除的个数就OK了~

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<vector>
#include<map>
#include<queue>
using namespace std; int n,m,k,x,y,z,cnt;
struct sdt
{
int to,len;
bool flag;
};
vector<sdt>v[100005];
long long dis[100005];
bool par[100005]; void spfa()
{
priority_queue<pair<long long,int>,vector<pair<long long,int> >,greater<pair<long long,int> > >q;
bool vis[100005]={0};
q.push(make_pair(0,1));
vis[1]=1;
while(!q.empty())
{
int s=q.top().second;
vis[s]=0;
q.pop();
for(int i=0;i<v[s].size();i++)
{
sdt p=v[s][i];
if(dis[s]!=1e18 && dis[p.to]>dis[s]+p.len)
{
dis[p.to]=dis[s]+p.len;
if(par[p.to]==1)
{
cnt--;
par[p.to]=0;
}
if(p.flag==1)
{
++cnt;
par[p.to]=1;
}
if(!vis[p.to])
{
q.push(make_pair(dis[p.to],p.to));
vis[p.to]=1;
}
}
else if(dis[s]!=1e18 && dis[p.to]==dis[s]+p.len)
{
if(!par[p.to])continue;
if(p.flag)continue;
par[p.to]=0;
cnt--;
}
}
}
} int main()
{
scanf("%d%d%d",&n,&m,&k);
for(int i=1;i<=m;i++)
{
scanf("%d%d%d",&x,&y,&z);
sdt p;
p.to=y;
p.len=z;
p.flag=0;
v[x].push_back(p);
p.to=x;
p.len=z;
p.flag=0;
v[y].push_back(p);
}
for(int i=1;i<=k;i++)
{
scanf("%d%d",&y,&z);
sdt p;
p.to=y;
p.len=z;
p.flag=1;
v[1].push_back(p);
p.to=1;
p.len=z;
p.flag=1;
v[y].push_back(p);
}
for(int i=2;i<=n;i++)
{
dis[i]=1e18;
}
spfa();
printf("%d\n",k-cnt);
return 0;
}
 
 
C. Jzzhu and Apples
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Jzzhu has picked n apples from his big apple tree. All the apples are numbered from 1 to n. Now he wants to sell them to an apple store.

Jzzhu will pack his apples into groups and then sell them. Each group must contain two apples, and the greatest common divisor of numbers of the apples in each group must be greater than 1. Of course, each apple can be part of at most one group.

Jzzhu wonders how to get the maximum possible number of groups. Can you help him?

Input

A single integer n (1 ≤ n ≤ 105), the number of the apples.

Output

The first line must contain a single integer m, representing the maximum number of groups he can get. Each of the next m lines must contain two integers — the numbers of apples in the current group.

If there are several optimal answers you can print any of them.

Examples
input
6
output
2
6 3
2 4
input
9
output
3
9 3
2 4
6 8
input
2
output
0

思路:这是数论问题。显然若是偶数则随便组合,奇数的话,若是某质数的倍数随便组合(若在N以内此质数倍数个数为奇数,则2倍项留给偶数之后处理,否则立即匹配),当然要打标记是否用过。上述方式即可保证最优!易证。

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<vector>
#include<map>
#include<queue>
#include<cstring>
using namespace std; int n,cnt;
bool vis[100005];
vector<pair<int,int> >v;
bool p[100005]; void prime()
{
memset(p,1,sizeof(p));
p[1]=0;
for(int i=2;i<=n;i++)
{
if(p[i])
{
for(int j=i*2;j<=n;j+=i)
{
p[j]=0;
}
}
}
} int main()
{
scanf("%d",&n);
prime();
for(int i=3;i<=n/2;i++)
{
if(!p[i] || vis[i])continue;
int sum=0;
for(int j=1;j<=n/i;j++)if(!vis[i*j])sum++;
if(sum%2==0)
{
for(int j=1;j<=n/i;j++)
{
if(j+1>n/i)break;
if(vis[i*j])
{
continue;
}
else if(vis[i*(j+1)])
{
int k;
for(k=j+2;k<=n/i;k++)
{
if(!vis[i*k])
{
v.push_back(make_pair(j*i,i*k));
vis[j*i]=vis[i*k]=1;
++cnt;
break;
}
}
j=k;
continue;
}
v.push_back(make_pair(j*i,i*(j+1)));
vis[j*i]=vis[i*(j+1)]=1;
j++;
++cnt;
}
}
else
{
for(int j=1;j<=n/i;j++)
{
if(j+1>n/i)break;
if(j==2)continue;
if(vis[i*j])
{
continue;
}
else if(vis[i*(j+1)] || j+1==2)
{
int k;
for(k=j+2;k<=n/i;k++)
{
if(!vis[i*k])
{
v.push_back(make_pair(j*i,i*k));
vis[j*i]=vis[i*k]=1;
++cnt;
break;
}
}
j=k;
continue;
}
v.push_back(make_pair(j*i,i*(j+1)));
vis[j*i]=vis[i*(j+1)]=1;
j++;
++cnt;
}
}
} for(int i=1;i<=n/2;i++)
{
if(i+1>n/2)break;
if(vis[i*2])continue;
else if(vis[2*(i+1)])
{
int j;
for(j=i+2;j<=n/2;j++)
{
if(!vis[2*j])
{
v.push_back(make_pair(2*i,2*j));
vis[2*i]=vis[2*j]=1;
++cnt;
break;
}
}
i=j;
continue;
}
v.push_back(make_pair(2*i,2*i+2));
vis[2*i]=vis[2*(i+1)]=1;
i++;
++cnt;
} printf("%d\n",cnt);
for(int i=0;i<cnt;i++)
{
printf("%d %d\n",v[i].first,v[i].second);
}
return 0;
}

  

Codeforces Round #257 (Div. 1)A~C(DIV.2-C~E)题解的更多相关文章

  1. 【Codeforces Round 1129】Alex Lopashev Thanks-Round (Div. 1)

    Codeforces Round 1129 这场模拟比赛做了\(A1\).\(A2\).\(B\).\(C\),\(Div.1\)排名40. \(A\)题是道贪心,可以考虑每一个站点是分开来的,把目的 ...

  2. Codeforces Round #257 (Div. 1) C. Jzzhu and Apples (素数筛)

    题目链接:http://codeforces.com/problemset/problem/449/C 给你n个数,从1到n.然后从这些数中挑选出不互质的数对最多有多少对. 先是素数筛,显然2的倍数的 ...

  3. Codeforces Round #257 (Div. 2) B. Jzzhu and Sequences (矩阵快速幂)

    题目链接:http://codeforces.com/problemset/problem/450/B 题意很好懂,矩阵快速幂模版题. /* | 1, -1 | | fn | | 1, 0 | | f ...

  4. Codeforces Round #257 (Div. 1)449A - Jzzhu and Chocolate(贪婪、数学)

    主题链接:http://codeforces.com/problemset/problem/449/A ------------------------------------------------ ...

  5. Codeforces Round #257 (Div. 2) A. Jzzhu and Children(简单题)

    题目链接:http://codeforces.com/problemset/problem/450/A ------------------------------------------------ ...

  6. Codeforces Round #257(Div. 2) B. Jzzhu and Sequences(矩阵高速幂)

    题目链接:http://codeforces.com/problemset/problem/450/B B. Jzzhu and Sequences time limit per test 1 sec ...

  7. Codeforces Round #257 (Div. 2)

    A - Jzzhu and Children 找到最大的ceil(ai/m)即可 #include <iostream> #include <cmath> using name ...

  8. Codeforces Round #257(Div.2) D Jzzhu and Cities --SPFA

    题意:n个城市,中间有m条道路(双向),再给出k条铁路,铁路直接从点1到点v,现在要拆掉一些铁路,在保证不影响每个点的最短距离(距离1)不变的情况下,问最多能删除多少条铁路 分析:先求一次最短路,铁路 ...

  9. Codeforces Round #257 (Div. 2) B

    B. Jzzhu and Sequences time limit per test 1 second memory limit per test 256 megabytes input standa ...

随机推荐

  1. spring boot + neo4j restful

    整整折腾了三天,终于把spring boot + neo4j的路走通了. 这里介绍3个部分,pom,entity,repository 1)pom <?xml version="1.0 ...

  2. CSS实现三角形方法一--rotate+relative

    方法说明:两个正方形,一个小的,一个大的,将大的正方向进行旋转,然后移动到小的正方形的合适位置,覆盖小正方形的一部分,使小正方形剩余部分为三角形,再把大正方形的背景色改为浏览器窗口的颜色. 用到知识: ...

  3. Java笔记——XML解析

    import java.io.File; import java.io.IOException; import javax.xml.parsers.DocumentBuilder; import ja ...

  4. <Natural Language Processing with Python>学习笔记二

    用Enthought Canopy作图果然方便.昨天频频出现无法识别pylab模块的异常,今天终于搞好了.以下是今天出来的图:

  5. Grunt 入门

    转自:http://user.qzone.qq.com/174629171/blog/1404433906 Grunt被定义为:the javascript task runner. 什么算是Java ...

  6. html中的图片、css、js等路径加载问题

    网页文件的存取路径有3种:物理路径.绝对路径和相对路径. 物理路径就是你的文件放在主机上的具体位置,例如:D:\\image\\1.jpg 这种格式,该方法可以很快确定出你的文件,但是在网页显示路径基 ...

  7. iOS开发实现Label中多颜色多字体

     UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(8, 100, 300, 30)]; label.textColor = wor ...

  8. view添加阴影无效

    需求:需要给cell里的imageview添加阴影 问题:按照标准的代码添加阴影,然并卵:代码如下: imageview.layer.shadowColor = [[UIColor blackColo ...

  9. leetcode--010 Linked List Cycle II

    aaarticlea/png;base64,iVBORw0KGgoAAAANSUhEUgAAApAAAACICAIAAADfzUzYAAANeklEQVR4nO3dQa7bthbG8W4mK/A+so

  10. LIBPNG

    libpng 库的源码包中有个 example.c ,里面包含PNG文件读/写的示例代码,参考示例代码和注释(虽然是英文的),可以了解大致的用法. 以下是读取PNG图片的图像数据的代码,使用前还需要按 ...